<?xml version="1.0" encoding="UTF-8"?>
<!--
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) XXXX-2008 - INRIA
 * 
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at    
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 -->
<refentry version="5.0-subset Scilab" xml:id="file" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns4="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">
  <info>
    <pubdate>$LastChangedDate$</pubdate>
  </info>

  <refnamediv>
    <refname>file</refname>

    <refpurpose>file management</refpurpose>
  </refnamediv>

  <refsynopsisdiv>
    <title>Calling Sequence</title>

    <synopsis>[unit [,err]]=file('open', file-name [,status] [,access [,recl]] [,format])
file(action,unit)
[units [,typ [,nams [,mod [,swap]]]]] = file([unit])</synopsis>
  </refsynopsisdiv>

  <refsection>
    <title>Parameters</title>

    <variablelist>
      <varlistentry>
        <term>file-name</term>

        <listitem>
          <para>string, file name of the file to be opened</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>status</term>

        <listitem>
          <para>string, The status of the file to be opened</para>

          <variablelist>
            <varlistentry>
              <term>"new"</term>

              <listitem>
                <para>file must not exist new file (default)</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"old"</term>

              <listitem>
                <para>file must already exists.</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"unknown"</term>

              <listitem>
                <para>unknown status</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"scratch"</term>

              <listitem>
                <para>file is to be deleted at end of session</para>
              </listitem>
            </varlistentry>
          </variablelist>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>access</term>

        <listitem>
          <para>string, The type of access to the file</para>

          <variablelist>
            <varlistentry>
              <term>"sequential"</term>

              <listitem>
                <para>sequential access (default)</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"direct"</term>

              <listitem>
                <para>direct access.</para>
              </listitem>
            </varlistentry>
          </variablelist>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>format</term>

        <listitem>
          <para>string,</para>

          <variablelist>
            <varlistentry>
              <term>"formatted"</term>

              <listitem>
                <para>for a formatted file (default)</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"unformatted"</term>

              <listitem>
                <para>binary record.</para>
              </listitem>
            </varlistentry>
          </variablelist>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>recl</term>

        <listitem>
          <para>integer,is the size of records in bytes when
          <literal>access="direct"</literal></para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>unit</term>

        <listitem>
          <para>integer, logical unit descriptor of the opened file</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>units</term>

        <listitem>
          <para>integer vector, logical unit descriptor of the opened files.
          Units 5 and 6 (%io) are reserved by the system for input and output
          devices.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>typs</term>

        <listitem>
          <para>Character string vector, type (C or Fortran) of opened
          files.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>nams</term>

        <listitem>
          <para>Character string vector, pathnames of opened files.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>mod</term>

        <listitem>
          <para>file opening mode. Formed by three digits abc</para>

          <variablelist>
            <varlistentry>
              <term>Fortran files</term>

              <listitem>
                <variablelist>
                  <varlistentry>
                    <term>a</term>

                    <listitem>
                      <para>0 stands for formatted and 1 for unformatted
                      (binary)</para>
                    </listitem>
                  </varlistentry>

                  <varlistentry>
                    <term>b</term>

                    <listitem>
                      <para>0 stands for sequential acces and 1 for direct
                      access</para>
                    </listitem>
                  </varlistentry>

                  <varlistentry>
                    <term>c</term>

                    <listitem>
                      <para>0 stands for "new", 1 for "old", 2 for "scratch"
                      and 3 for "unknown"</para>
                    </listitem>
                  </varlistentry>
                </variablelist>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>C files</term>

              <listitem>
                <variablelist>
                  <varlistentry>
                    <term>a</term>

                    <listitem>
                      <para>is 1 if file has been opened with a "b" (binary)
                      mode</para>
                    </listitem>
                  </varlistentry>

                  <varlistentry>
                    <term>b</term>

                    <listitem>
                      <para>is 1 if file has been opened with a "+" (updating)
                      mode</para>
                    </listitem>
                  </varlistentry>

                  <varlistentry>
                    <term>c</term>

                    <listitem>
                      <para>1 stands for "r" (read), 2 stands for "w" (write)
                      and 3 for "a" (append)</para>
                    </listitem>
                  </varlistentry>
                </variablelist>
              </listitem>
            </varlistentry>
          </variablelist>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>swap</term>

        <listitem>
          <para>automatic swap switch. swap=1 if automatic swap is on. swap is
          always 0 for Fortran files.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>err</term>

        <listitem>
          <para>integer, error message number (see error), if open fails. If
          err is omitted an error message is issued.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>action</term>

        <listitem>
          <para>is one of the following strings:</para>

          <variablelist>
            <varlistentry>
              <term>"close"</term>

              <listitem>
                <para>closes the file(s) given by the logical unit descriptors
                given in <literal>units</literal></para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"rewind"</term>

              <listitem>
                <para>puts the pointer at beginning of file</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"backspace"</term>

              <listitem>
                <para>puts the pointer at beginning of last record.</para>
              </listitem>
            </varlistentry>

            <varlistentry>
              <term>"last"</term>

              <listitem>
                <para>puts the pointer after last record.</para>
              </listitem>
            </varlistentry>
          </variablelist>
        </listitem>
      </varlistentry>
    </variablelist>
  </refsection>

  <refsection>
    <title>Description</title>

    <para>selects a logical unit <literal>unit</literal> and manages the file
    <literal>file-name</literal>.</para>

    <para><literal>[unit [,err]]=file('open', file-name [,status] [,access
    [,recl]][,format])</literal> allows to open a file with specified
    properties and to get the associated unit number <literal>unit</literal>.
    This unit number may be used for further actions on this file or as file
    descriptor in <literal>read</literal>, <literal>write</literal>,
    <literal>readb</literal>,
    <literal>writb</literal>,<literal>save</literal>, <literal>load</literal>
    function calls.</para>

    <para>This function can not open a UTF filename. In this case, please uses
    mopen.</para>

    <para><literal>file(action,unit)</literal> allows to close the file , or
    move the current file pointer .</para>

    <para><literal>file()</literal> returns the logical unit descriptors of
    the opened files. So <literal>file('close',file() )</literal> closes all
    user opened files (C or Fortran type).</para>
  </refsection>

  <refsection>
    <title>Examples</title>

    <programlisting role="example"><![CDATA[ 
u=file('open',TMPDIR+'/foo','unknown')
for k=1:4
  a=rand(1,4)
  write(u,a)
end
file('rewind',u)
x=read(u,2,4)
file('close',u)
//
u1=file('open',TMPDIR+'/foo','unknown')
u2=mopen(TMPDIR+'/foo1','wb')
[units,typs,nams]=file()
file('close',u1);
mclose(u2);
 ]]></programlisting>
  </refsection>

  <refsection>
    <title>See Also</title>

    <simplelist type="inline">
      <member><link linkend="save">save</link></member>

      <member><link linkend="load">load</link></member>

      <member><link linkend="write">write</link></member>

      <member><link linkend="read">read</link></member>

      <member><link linkend="writb">writb</link></member>

      <member><link linkend="readb">readb</link></member>

      <member><link linkend="uigetfile">uigetfile</link></member>

      <member><link linkend="mopen">mopen</link></member>

      <member><link linkend="mclose">mclose</link></member>
      
      <member><link linkend="file">file</link></member>
    </simplelist>
  </refsection>
</refentry>
